<template>
  <Dialog :title="dialogTitle" v-model="dialogVisible">
    <el-form
      ref="formRef"
      :model="formData"
      :rules="formRules"
      label-width="100px"
      v-loading="formLoading"
    >
      <el-form-item label="用户id" prop="bqrdUserId">
        <el-input v-model="formData.bqrdUserId" placeholder="请输入用户id" />
      </el-form-item>
      <el-form-item label="答卷结果id" prop="bqrdQuestionnaireResultId">
        <el-input v-model="formData.bqrdQuestionnaireResultId" placeholder="请输入答卷结果id" />
      </el-form-item>
      <el-form-item label="问卷id" prop="bqrdQuestionnaireId">
        <el-input v-model="formData.bqrdQuestionnaireId" placeholder="请输入问卷id" />
      </el-form-item>
      <el-form-item label="试题id" prop="bqrdQuestionId">
        <el-input v-model="formData.bqrdQuestionId" placeholder="请输入试题id" />
      </el-form-item>
      <el-form-item label="选择" prop="bqrdQuestOptionId">
        <el-input v-model="formData.bqrdQuestOptionId" placeholder="请输入选择" />
      </el-form-item>
      <el-form-item label="是否答对" prop="bqrdIsCorrect">
        <el-radio-group v-model="formData.bqrdIsCorrect">
          <el-radio
            v-for="dict in getStrDictOptions(DICT_TYPE.BJDX_QUEST_IS_CORRECT)"
            :key="dict.value"
            :label="dict.value"
          >
            {{ dict.label }}
          </el-radio>
        </el-radio-group>
      </el-form-item>
      <el-form-item label="试题得分" prop="bqrdQuestSorce">
        <el-input v-model="formData.bqrdQuestSorce" placeholder="请输入试题得分" />
      </el-form-item>
    </el-form>
    <template #footer>
      <el-button @click="submitForm" type="primary" :disabled="formLoading">确 定</el-button>
      <el-button @click="dialogVisible = false">取 消</el-button>
    </template>
  </Dialog>
</template>
<script setup lang="ts">
import { getStrDictOptions, DICT_TYPE } from '@/utils/dict'
import { QuestionnaireResultDetailsApi, QuestionnaireResultDetailsVO } from '@/api/bjdxResult/questionnaireresultdetails'

/** 问卷结果-详情 表单 */
defineOptions({ name: 'QuestionnaireResultDetailsForm' })

const { t } = useI18n() // 国际化
const message = useMessage() // 消息弹窗

const dialogVisible = ref(false) // 弹窗的是否展示
const dialogTitle = ref('') // 弹窗的标题
const formLoading = ref(false) // 表单的加载中：1）修改时的数据加载；2）提交的按钮禁用
const formType = ref('') // 表单的类型：create - 新增；update - 修改
const formData = ref({
  id: undefined,
  bqrdUserId: undefined,
  bqrdQuestionnaireResultId: undefined,
  bqrdQuestionnaireId: undefined,
  bqrdQuestionId: undefined,
  bqrdQuestOptionId: undefined,
  bqrdIsCorrect: undefined,
  bqrdQuestSorce: undefined,
  tenantId: undefined,
})
const formRules = reactive({
})
const formRef = ref() // 表单 Ref

/** 打开弹窗 */
const open = async (type: string, id?: number) => {
  dialogVisible.value = true
  dialogTitle.value = t('action.' + type)
  formType.value = type
  resetForm()
  // 修改时，设置数据
  if (id) {
    formLoading.value = true
    try {
      formData.value = await QuestionnaireResultDetailsApi.getQuestionnaireResultDetails(id)
    } finally {
      formLoading.value = false
    }
  }
}
defineExpose({ open }) // 提供 open 方法，用于打开弹窗

/** 提交表单 */
const emit = defineEmits(['success']) // 定义 success 事件，用于操作成功后的回调
const submitForm = async () => {
  // 校验表单
  await formRef.value.validate()
  // 提交请求
  formLoading.value = true
  try {
    const data = formData.value as unknown as QuestionnaireResultDetailsVO
    if (formType.value === 'create') {
      await QuestionnaireResultDetailsApi.createQuestionnaireResultDetails(data)
      message.success(t('common.createSuccess'))
    } else {
      await QuestionnaireResultDetailsApi.updateQuestionnaireResultDetails(data)
      message.success(t('common.updateSuccess'))
    }
    dialogVisible.value = false
    // 发送操作成功的事件
    emit('success')
  } finally {
    formLoading.value = false
  }
}

/** 重置表单 */
const resetForm = () => {
  formData.value = {
    id: undefined,
    bqrdUserId: undefined,
    bqrdQuestionnaireResultId: undefined,
    bqrdQuestionnaireId: undefined,
    bqrdQuestionId: undefined,
    bqrdQuestOptionId: undefined,
    bqrdIsCorrect: undefined,
    bqrdQuestSorce: undefined,
    tenantId: undefined,
  }
  formRef.value?.resetFields()
}
</script>
